## alfa 0.98

=== Makefile ===
#----------------------------------------------------------------
# Makefile based on the one written for NEAT by Peter Scicluna
# How to call:
# calling as normal
#     > make
# will trigger the default compiler options which include optimisation.
#
# You can now also call using
#     > make CO=debug
# for extra warnings, gprof and gdb output, exception trapping
# at runtime, and bounds-checking.
# This option is slow (about 2x slower than make all)
#
#     > make CO=debug2, debug3, pedantic
# offer further levels of checks in case of problems
#
#     > make new
# simply calls clean then all to force a re-build.
#
#     > (sudo) make install
# places the files in the standard UNIX directories.
#----------------------------------------------------------------

FC=gfortran
LD=gfortran
PREFIX=/usr
VERSION := $(shell git describe --always --tags --dirty)
FFLAGS+=-cpp -DPREFIX=\"${PREFIX}\" -DVERSION=\"${VERSION}\"
LDFLAGS+=
CFITSIOFLAGS=-lcfitsio -lm #-L/usr/lib/x86_64-linux-gnu/
MANDIR=${DESTDIR}${PREFIX}/share/man/man1

ifeq ($(FC),gfortran)
  FFLAGS += -ffree-line-length-0 -Jsource/ -fopenmp
  ifeq ($(CO),debug)
    FFLAGS += -fbounds-check -Wall -Wuninitialized -DCO=\"${CO}\" #-ffpe-trap=zero,overflow,invalid,underflow,denormal
  else ifeq ($(CO),debug2)
    FFLAGS += -g -pg -fbounds-check -Wall -Wuninitialized -DCO=\"${CO}\" #-ffpe-trap=zero,overflow,invalid,underflow,denormal
  else ifeq ($(CO),debug3)
    FFLAGS += -g -pg -fbounds-check -Wall -Wuninitialized -ffpe-trap=zero,overflow,invalid,underflow,denormal -DCO=\"${CO}\"
  else ifeq ($(CO),pedantic)
    FFLAGS += -g -pg -fbounds-check -Wall -Wuninitialized -Werror -pedantic -ffpe-trap=zero,overflow,invalid,underflow,denormal -DCO=\"${CO}\"
  else
    FFLAGS += -O3 -fno-backtrace
  endif
endif

ifeq ($(FC),ifort)
  FFLAGS += -module source/ -openmp
  LD=ifort
  ifeq ($(CO),debug)
    FFLAGS += -pg -g -check bounds -check uninit -warn all -warn nodeclarations -WB -zero -traceback -DCO=\"${CO}\" # -std
  else ifeq ($(CO),pedantic)
    FFLAGS += -pg -g -check bounds -check uninit -warn all -warn nodeclarations -WB -zero -traceback -std -DCO=\"${CO}\"
  else
    FFLAGS += -axavx -msse3 -O3 -ip -ipo # for today's CPUs
#    FFLAGS = -fast -tune pn4 # for older pentium 4
  endif
endif

.PHONY: all clean install new

all: alfa

new: clean all

%.o: %.f90
	$(FC) $(FFLAGS) $< -c -o $@

alfa: source/types.o source/functions.o source/commandline.o source/readfiles.o source/quicksort.o source/continuum.o source/linefit.o source/uncertainties.o source/alfa.o
	$(LD) $(LDFLAGS) $(FFLAGS) -o $@ $^ ${CFITSIOFLAGS}

clean:
	rm -f alfa source/*.o source/*.mod

install:
	test -e ${DESTDIR}${PREFIX}/share/alfa || mkdir -p ${DESTDIR}${PREFIX}/share/alfa
	test -e ${DESTDIR}${PREFIX}/bin || mkdir -p ${DESTDIR}${PREFIX}/bin
	test -e ${MANDIR} || mkdir -p ${MANDIR}
	install -m 644 linelists/* ${DESTDIR}${PREFIX}/share/alfa
	install alfa ${DESTDIR}${PREFIX}/bin
	install -m 644 man/alfa.1 ${MANDIR}
	-test -e ${DESTDIR}${PREFIX}/share/bash-completion/completions && install -m 644 source/bashcompletion ${DESTDIR}${PREFIX}/share/bash-completion/completions/alfa
	gzip -f ${MANDIR}/alfa.1

uninstall:
	rm -rf ${DESTDIR}${PREFIX}/share/alfa
	rm -f ${DESTDIR}${PREFIX}/bin/alfa
	rm -f ${DESTDIR}${PREFIX}/share/bash-completion/completions/alfa
	rm -f ${MANDIR}/alfa.1.gz

=== debian/changelog ===
alfa (0.98-1) unstable; urgency=low

  * Initial release (Closes: #809507)

 -- Roger Wesson <rw@nebulousresearch.org>  Wed, 25 May 2016 22:38:47 -0300

=== debian/control ===
Source: alfa
Section: science
Priority: optional
Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Roger Wesson <rw@nebulousresearch.org>
Build-Depends: debhelper (>= 9.0.0),
               gfortran,
               libc6 (>= 2.14),
               libcfitsio3-dev (>= 3.060) | libcfitsio-dev (>= 3.060),
               libgfortran3 (>= 4.6),
               libgomp1 (>= 4.2.1)
Standards-Version: 3.9.8
Homepage: https://github.com/rwesson/ALFA
Vcs-Git: https://anonscm.debian.org/git/debian-astro/packages/alfa.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-astro/packages/alfa.git

Package: alfa
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Automated Line Fitting Algorithm
 ALFA measures fluxes in emission line spectra, such as those of planetary
 nebulae and HII regions, using a genetic algorithm to rapidly optimise fits
 to large numbers of lines simultaneously.  It can subtract night sky emission
 lines before fitting the nebular lines if necessary.  It can read plain text
 files containing 1D spectral data, or FITS files containing 1D, 2D or 3D
 datasets.

## alfa 1.0

=== Makefile ===
--- 
+++ 
@@ -71,7 +71,7 @@
 	$(LD) $(LDFLAGS) $(FFLAGS) -o $@ $^ ${CFITSIOFLAGS}
 
 clean:
-	rm -f alfa source/*.o source/*.mod
+	rm -f alfa source/*.o source/*.mod man/alfa.html
 
 install:
 	test -e ${DESTDIR}${PREFIX}/share/alfa || mkdir -p ${DESTDIR}${PREFIX}/share/alfa
@@ -80,7 +80,8 @@
 	install -m 644 linelists/* ${DESTDIR}${PREFIX}/share/alfa
 	install alfa ${DESTDIR}${PREFIX}/bin
 	install -m 644 man/alfa.1 ${MANDIR}
-	-test -e ${DESTDIR}${PREFIX}/share/bash-completion/completions && install -m 644 source/bashcompletion ${DESTDIR}${PREFIX}/share/bash-completion/completions/alfa
+	test -e ${DESTDIR}${PREFIX}/share/bash-completion/completions || mkdir -p ${DESTDIR}${PREFIX}/share/bash-completion/completions
+	install -m 644 source/bashcompletion ${DESTDIR}${PREFIX}/share/bash-completion/completions/alfa
 	gzip -f ${MANDIR}/alfa.1
 
 uninstall:
@@ -88,3 +89,6 @@
 	rm -f ${DESTDIR}${PREFIX}/bin/alfa
 	rm -f ${DESTDIR}${PREFIX}/share/bash-completion/completions/alfa
 	rm -f ${MANDIR}/alfa.1.gz
+
+htmlmanual:
+	groff -m mandoc -Thtml man/alfa.1 > man/alfa.html

=== debian/changelog ===
alfa (1.0-3build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:32:44 +0100

alfa (1.0-3build1) eoan; urgency=medium

  * No-change rebuild against libcfitsio8

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 04 Aug 2019 05:45:47 +0000

alfa (1.0-3) unstable; urgency=low

  * updated repository URLs

 -- Roger Wesson <rw@nebulousresearch.org>  Sat, 25 Aug 2018 11:11:25 +0100

alfa (1.0-2) unstable; urgency=low

  * simplified build dependencies (Closes: #842197)

 -- Roger Wesson <rw@nebulousresearch.org>  Mon, 31 Oct 2016 14:43:13 +0000

alfa (1.0-1) unstable; urgency=low

  * more robust FITS handling, support for logarithmically sampled spectra
  * fixed libcfitsio dependency (Closes: #841658)

 -- Roger Wesson <rw@nebulousresearch.org>  Tue, 25 Oct 2016 23:05:14 +0100

=== debian/control ===
Source: alfa
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Roger Wesson <rw@nebulousresearch.org>
Build-Depends: debhelper (>= 11.0.0),
               gfortran,
               libcfitsio-dev
Standards-Version: 4.1.4
Homepage: https://github.com/rwesson/ALFA
Vcs-Git: https://salsa.debian.org/debian-astro-team/alfa.git
Vcs-Browser: https://salsa.debian.org/debian-astro-team/alfa

Package: alfa
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Automated Line Fitting Algorithm
 ALFA measures fluxes in emission line spectra, such as those of planetary
 nebulae and HII regions, using a genetic algorithm to rapidly optimise fits
 to large numbers of lines simultaneously.  It can subtract night sky emission
 lines before fitting the nebular lines if necessary.  It can read plain text
 files containing 1D spectral data, or FITS files containing 1D, 2D or 3D
 datasets.

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/ALFA-$1\.tar\.gz/ \
  https://github.com/rwesson/ALFA/tags .*/v?(\d\S*)\.tar\.gz

## alfa 2.1

=== debian/changelog ===
alfa (2.1-1) unstable; urgency=medium

  * new upstream release
  * updated packaging files to latest standards

 -- Roger Wesson <rw@nebulousresearch.org>  Mon, 08 Feb 2021 15:38:58 +0000

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: alfa
 Section: science
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
 Uploaders: Roger Wesson <rw@nebulousresearch.org>
-Build-Depends: debhelper (>= 11.0.0),
+Build-Depends: debhelper-compat (= 13),
                gfortran,
                libcfitsio-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.5.1
 Homepage: https://github.com/rwesson/ALFA
+Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/debian-astro-team/alfa.git
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/alfa

## alfa 2.2

=== Makefile ===
#----------------------------------------------------------------
# Makefile based on the one written for NEAT by Peter Scicluna
# How to call:
# calling as normal
#     > make
# will trigger the default compiler options which include optimisation.
#
# You can now also call using
#     > make CO=debug
# for extra warnings, gprof and gdb output, exception trapping
# at runtime, and bounds-checking.
# This option is slow (about 2x slower than make all)
#
#     > make CO=debug2, debug3, pedantic
# offer further levels of checks in case of problems
#
#     > make new
# simply calls clean then all to force a re-build.
#
#     > (sudo) make install
# places the files in the standard UNIX directories.
#----------------------------------------------------------------

FC=gfortran
LD=gfortran

# set prefix depending on OS
OS := $(shell uname)
ifeq ($(OS),Darwin)
  PREFIX=/usr/local
else
  PREFIX=/usr
endif

# get version from changelog if debian package, or git log otherwise
VERSION := $(shell if [ -e debian/ ]; then dpkg-parsechangelog -S version; elif [ -e .git/ ]; then git describe --always --tags --dirty; fi)

FFLAGS+=-cpp -DPREFIX=\"$(PREFIX)\" -DVERSION=\"$(VERSION)\"
LDFLAGS+=
CFITSIOFLAGS=-lcfitsio -lm #-L/usr/lib/x86_64-linux-gnu/
MANDIR=$(DESTDIR)$(PREFIX)/share/man/man1

ifeq ($(FC),gfortran)
  FFLAGS += -ffree-line-length-0 -Jsource/ -fopenmp
  ifeq ($(CO),debug)
    FFLAGS += -fbounds-check -Wall -Wuninitialized -DCO=\"$(CO)\" #-ffpe-trap=zero,overflow,invalid,underflow,denormal
  else ifeq ($(CO),debug2)
    FFLAGS += -g -pg -fbounds-check -Wall -Wuninitialized -DCO=\"$(CO)\" #-ffpe-trap=zero,overflow,invalid,underflow,denormal
  else ifeq ($(CO),debug3)
    FFLAGS += -g -pg -fbounds-check -Wall -Wuninitialized -ffpe-trap=zero,overflow,invalid,underflow,denormal -DCO=\"$(CO)\"
  else ifeq ($(CO),pedantic)
    FFLAGS += -g -pg -fbounds-check -Wall -Wuninitialized -Werror -pedantic -ffpe-trap=zero,overflow,invalid,underflow,denormal -DCO=\"$(CO)\"
  else
    FFLAGS += -O3 -fno-backtrace
  endif
endif

ifeq ($(FC),ifort)
  FFLAGS += -module source/ -openmp
  LD=ifort
  ifeq ($(CO),debug)
    FFLAGS += -pg -g -check bounds -check uninit -warn all -warn nodeclarations -WB -zero -traceback -DCO=\"$(CO)\" # -std
  else ifeq ($(CO),pedantic)
    FFLAGS += -pg -g -check bounds -check uninit -warn all -warn nodeclarations -WB -zero -traceback -std -DCO=\"$(CO)\"
  else
    FFLAGS += -O3 -ip -ipo # for today's CPUs
#    FFLAGS = -fast -tune pn4 # for older pentium 4
  endif
endif

.PHONY: all clean install new

all: alfa

new: clean all

%.o: %.f90
	$(FC) $(FFLAGS) $< -c -o $@

alfa: source/rnglib.o source/types.o source/globals.o source/functions.o source/output.o source/commandline.o source/readfiles.o source/quicksort.o source/continuum.o source/linefit.o source/uncertainties.o source/alfa.o
	$(LD) $(LDFLAGS) $(FFLAGS) -o $@ $^ $(CFITSIOFLAGS)
	@echo "Compilation complete"

clean:
	rm -f alfa source/*.o source/*.mod man/alfa.html

install: alfa
	test -e $(DESTDIR)$(PREFIX)/share/alfa || mkdir -p $(DESTDIR)$(PREFIX)/share/alfa
	test -e $(DESTDIR)$(PREFIX)/bin || mkdir -p $(DESTDIR)$(PREFIX)/bin
	test -e $(MANDIR) || mkdir -p $(MANDIR)
	install -m 644 linelists/* $(DESTDIR)$(PREFIX)/share/alfa
	install alfa $(DESTDIR)$(PREFIX)/bin
	install -m 644 man/alfa.1 $(MANDIR)
	test -e $(DESTDIR)$(PREFIX)/share/bash-completion/completions || mkdir -p $(DESTDIR)$(PREFIX)/share/bash-completion/completions
	install -m 644 source/bashcompletion $(DESTDIR)$(PREFIX)/share/bash-completion/completions/alfa
	gzip -f $(MANDIR)/alfa.1
	@echo "Installation complete"

fittest: alfa
	@mkdir -p testoutput
	@printf "testing reading and fitting of data formats:\n"
	@printf " ..1d ascii"
	@./alfa test/1d.ascii --output-dir testoutput && printf "....success!\n"
	@printf " ..1d fits image"
	@./alfa test/1d.fits --output-dir testoutput && printf "....success!\n"
	@printf " ..2d fits image (also tests image section handling)"
	@./alfa test/2d_small.fits[*,1:2] --output-dir testoutput && printf "....success!\n"
	@printf " ..3d fits image"
	@./alfa test/3dspec_2x2.fits --output-dir testoutput && printf "....success!\n"
	@printf " ..3d fits image collapsed"
	@./alfa test/3dspec_2x2.fits --collapse --output-dir testoutput && printf "....success!\n"
	@printf "all tests ran successfully!\n"
	@rm -rf testoutput

uninstall:
	rm -rf $(DESTDIR)$(PREFIX)/share/alfa
	rm -f $(DESTDIR)$(PREFIX)/bin/alfa
	rm -f $(DESTDIR)$(PREFIX)/share/bash-completion/completions/alfa
	rm -f $(MANDIR)/alfa.1.gz

htmlmanual:
	groff -m mandoc -Thtml man/alfa.1 > man/alfa.html

=== debian/changelog ===
alfa (2.2-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:08:14 +1100

alfa (2.2-1build2) noble; urgency=high

  * No change rebuild against libcfitsio10t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 16:27:31 +0100

alfa (2.2-1build1) lunar; urgency=medium

  * No-change rebuild against libcfitsio10

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 24 Jan 2023 05:13:23 +0000

alfa (2.2-1) unstable; urgency=medium

  * new upstream release
  * updated standards-version

 -- Roger Wesson <rw@nebulousresearch.org>  Fri, 13 May 2022 14:47:32 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: alfa
 Section: science
 Priority: optional
-Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
 Uploaders: Roger Wesson <rw@nebulousresearch.org>
 Build-Depends: debhelper-compat (= 13),
                gfortran,
                libcfitsio-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Homepage: https://github.com/rwesson/ALFA
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/debian-astro-team/alfa.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --no-parallel
